--- old/usr/src/uts/common/fs/zfs/arc.c	Mon Aug  5 17:26:46 2019
+++ new/usr/src/uts/common/fs/zfs/arc.c	Mon Aug  5 17:26:46 2019
@@ -3655,13 +4191,18 @@
 {
 	multilist_t *data_ml = state->arcs_list[ARC_BUFC_DATA];
 	multilist_t *meta_ml = state->arcs_list[ARC_BUFC_METADATA];
+	multilist_t *ddt_ml = state->arcs_list[ARC_BUFC_DDT];
 	int data_idx = multilist_get_random_index(data_ml);
 	int meta_idx = multilist_get_random_index(meta_ml);
+	int ddt_idx = multilist_get_random_index(ddt_ml);
 	multilist_sublist_t *data_mls;
 	multilist_sublist_t *meta_mls;
-	arc_buf_contents_t type;
+	multilist_sublist_t *ddt_mls;
+	arc_buf_contents_t type = ARC_BUFC_DATA; /* silence compiler warning */
 	arc_buf_hdr_t *data_hdr;
 	arc_buf_hdr_t *meta_hdr;
+	arc_buf_hdr_t *ddt_hdr;
+	clock_t	oldest;
 
 	/*
 	 * We keep the sublist lock until we're finished, to prevent
@@ -3669,6 +4210,7 @@
 	 */
 	data_mls = multilist_sublist_lock(data_ml, data_idx);
 	meta_mls = multilist_sublist_lock(meta_ml, meta_idx);
+	ddt_mls = multilist_sublist_lock(ddt_ml, ddt_idx);
 
 	/*
 	 * These two loops are to ensure we skip any markers that
@@ -3687,22 +4229,71 @@
 			break;
 	}
 
-	if (data_hdr == NULL && meta_hdr == NULL) {
+	for (ddt_hdr = multilist_sublist_tail(ddt_mls); ddt_hdr != NULL;
+	    ddt_hdr = multilist_sublist_prev(ddt_mls, ddt_hdr)) {
+		if (ddt_hdr->b_spa != 0)
+			break;
+	}
+
+	if (data_hdr == NULL && meta_hdr == NULL && ddt_hdr == NULL) {
 		type = ARC_BUFC_DATA;
-	} else if (data_hdr == NULL) {
+	} else if (data_hdr != NULL && meta_hdr != NULL && ddt_hdr != NULL) {
+		/* The headers can't be on the sublist without an L1 header */
+		ASSERT(HDR_HAS_L1HDR(data_hdr));
+		ASSERT(HDR_HAS_L1HDR(meta_hdr));
+		ASSERT(HDR_HAS_L1HDR(ddt_hdr));
+
+		oldest = data_hdr->b_l1hdr.b_arc_access;
+		type = ARC_BUFC_DATA;
+		if (oldest > meta_hdr->b_l1hdr.b_arc_access) {
+			oldest = meta_hdr->b_l1hdr.b_arc_access;
+			type = ARC_BUFC_METADATA;
+		}
+		if (oldest > ddt_hdr->b_l1hdr.b_arc_access) {
+			type = ARC_BUFC_DDT;
+		}
+	} else if (data_hdr == NULL && ddt_hdr == NULL) {
 		ASSERT3P(meta_hdr, !=, NULL);
 		type = ARC_BUFC_METADATA;
-	} else if (meta_hdr == NULL) {
+	} else if (meta_hdr == NULL && ddt_hdr == NULL) {
 		ASSERT3P(data_hdr, !=, NULL);
 		type = ARC_BUFC_DATA;
-	} else {
-		ASSERT3P(data_hdr, !=, NULL);
-		ASSERT3P(meta_hdr, !=, NULL);
+	} else if (meta_hdr == NULL && data_hdr == NULL) {
+		ASSERT3P(ddt_hdr, !=, NULL);
+		type = ARC_BUFC_DDT;
+	} else if (data_hdr != NULL && ddt_hdr != NULL) {
+		ASSERT3P(meta_hdr, ==, NULL);
 
 		/* The headers can't be on the sublist without an L1 header */
 		ASSERT(HDR_HAS_L1HDR(data_hdr));
+		ASSERT(HDR_HAS_L1HDR(ddt_hdr));
+
+		if (data_hdr->b_l1hdr.b_arc_access <
+		    ddt_hdr->b_l1hdr.b_arc_access) {
+			type = ARC_BUFC_DATA;
+		} else {
+			type = ARC_BUFC_DDT;
+		}
+	} else if (meta_hdr != NULL && ddt_hdr != NULL) {
+		ASSERT3P(data_hdr, ==, NULL);
+
+		/* The headers can't be on the sublist without an L1 header */
 		ASSERT(HDR_HAS_L1HDR(meta_hdr));
+		ASSERT(HDR_HAS_L1HDR(ddt_hdr));
 
+		if (meta_hdr->b_l1hdr.b_arc_access <
+		    ddt_hdr->b_l1hdr.b_arc_access) {
+			type = ARC_BUFC_METADATA;
+		} else {
+			type = ARC_BUFC_DDT;
+		}
+	} else if (meta_hdr != NULL && data_hdr != NULL) {
+		ASSERT3P(ddt_hdr, ==, NULL);
+
+		/* The headers can't be on the sublist without an L1 header */
+		ASSERT(HDR_HAS_L1HDR(data_hdr));
+		ASSERT(HDR_HAS_L1HDR(meta_hdr));
+
 		if (data_hdr->b_l1hdr.b_arc_access <
 		    meta_hdr->b_l1hdr.b_arc_access) {
 			type = ARC_BUFC_DATA;
@@ -3709,8 +4300,12 @@
 		} else {
 			type = ARC_BUFC_METADATA;
 		}
+	} else {
+		/* should never get here */
+		ASSERT(0);
 	}
 
+	multilist_sublist_unlock(ddt_mls);
 	multilist_sublist_unlock(meta_mls);
 	multilist_sublist_unlock(data_mls);
 
@@ -3726,16 +4321,20 @@
 	uint64_t total_evicted = 0;
 	uint64_t bytes;
 	int64_t target;
-	uint64_t asize = aggsum_value(&arc_size);
-	uint64_t ameta = aggsum_value(&arc_meta_used);
 
 	/*
 	 * If we're over arc_meta_limit, we want to correct that before
 	 * potentially evicting data buffers below.
 	 */
-	total_evicted += arc_adjust_meta(ameta);
+	total_evicted += arc_adjust_meta_or_ddt(B_FALSE);
 
 	/*
+	 * If we're over arc_ddt_limit, we want to correct that before
+	 * potentially evicting data buffers below.
+	 */
+	total_evicted += arc_adjust_meta_or_ddt(B_TRUE);
+
+	/*
 	 * Adjust MRU size
 	 *
 	 * If we're over the target cache size, we want to evict enough
@@ -3745,9 +4344,9 @@
 	 * the MRU is over arc_p, we'll evict enough to get back to
 	 * arc_p here, and then evict more from the MFU below.
 	 */
-	target = MIN((int64_t)(asize - arc_c),
+	target = MIN((int64_t)(arc_size - arc_c),
 	    (int64_t)(refcount_count(&arc_anon->arcs_size) +
-	    refcount_count(&arc_mru->arcs_size) + ameta - arc_p));
+	    refcount_count(&arc_mru->arcs_size) + arc_meta_used - arc_p));
 
 	/*
 	 * If we're below arc_meta_min, always prefer to evict data.
@@ -3758,7 +4357,7 @@
 	 * type, spill over into the next type.
 	 */
 	if (arc_adjust_type(arc_mru) == ARC_BUFC_METADATA &&
-	    ameta > arc_meta_min) {
+	    arc_meta_used > arc_meta_min) {
 		bytes = arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_METADATA);
 		total_evicted += bytes;
 
@@ -3768,8 +4367,8 @@
 		 */
 		target -= bytes;
 
-		total_evicted +=
-		    arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_DATA);
+		bytes += arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_DATA);
+		total_evicted += bytes;
 	} else {
 		bytes = arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_DATA);
 		total_evicted += bytes;
@@ -3780,11 +4379,19 @@
 		 */
 		target -= bytes;
 
-		total_evicted +=
-		    arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_METADATA);
+		bytes += arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_METADATA);
+		total_evicted += bytes;
 	}
 
 	/*
+	 * If we couldn't evict our target number of bytes from
+	 * data and metadata, we try to get the rest from ddt.
+	 */
+	target -= bytes;
+	total_evicted +=
+	    arc_adjust_impl(arc_mru, 0, target, ARC_BUFC_DDT);
+
+	/*
 	 * Adjust MFU size
 	 *
 	 * Now that we've tried to evict enough from the MRU to get its
@@ -3791,10 +4398,10 @@
 	 * size back to arc_p, if we're still above the target cache
 	 * size, we evict the rest from the MFU.
 	 */
-	target = asize - arc_c;
+	target = arc_size - arc_c;
 
 	if (arc_adjust_type(arc_mfu) == ARC_BUFC_METADATA &&
-	    ameta > arc_meta_min) {
+	    arc_meta_used > arc_meta_min) {
 		bytes = arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_METADATA);
 		total_evicted += bytes;
 
@@ -3804,8 +4411,8 @@
 		 */
 		target -= bytes;
 
-		total_evicted +=
-		    arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_DATA);
+		bytes += arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_DATA);
+		total_evicted += bytes;
 	} else {
 		bytes = arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_DATA);
 		total_evicted += bytes;
@@ -3816,11 +4423,19 @@
 		 */
 		target -= bytes;
 
-		total_evicted +=
-		    arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_METADATA);
+		bytes += arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_METADATA);
+		total_evicted += bytes;
 	}
 
 	/*
+	 * If we couldn't evict our target number of bytes from
+	 * data and metadata, we try to get the rest from ddt.
+	 */
+	target -= bytes;
+	total_evicted +=
+	    arc_adjust_impl(arc_mfu, 0, target, ARC_BUFC_DDT);
+
+	/*
 	 * Adjust ghost lists
 	 *
 	 * In addition to the above, the ARC also defines target values
@@ -3839,8 +4454,13 @@
 
 	target -= bytes;
 
+	bytes += arc_adjust_impl(arc_mru_ghost, 0, target, ARC_BUFC_METADATA);
+	total_evicted += bytes;
+
+	target -= bytes;
+
 	total_evicted +=
-	    arc_adjust_impl(arc_mru_ghost, 0, target, ARC_BUFC_METADATA);
+	    arc_adjust_impl(arc_mru_ghost, 0, target, ARC_BUFC_DDT);
 
 	/*
 	 * We assume the sum of the mru list and mfu list is less than
@@ -3858,16 +4478,53 @@
 
 	target -= bytes;
 
+	bytes += arc_adjust_impl(arc_mfu_ghost, 0, target, ARC_BUFC_METADATA);
+	total_evicted += bytes;
+
+	target -= bytes;
+
 	total_evicted +=
-	    arc_adjust_impl(arc_mfu_ghost, 0, target, ARC_BUFC_METADATA);
+	    arc_adjust_impl(arc_mfu_ghost, 0, target, ARC_BUFC_DDT);
 
 	return (total_evicted);
 }
 
+typedef struct arc_async_flush_data {
+	uint64_t	aaf_guid;
+	boolean_t	aaf_retry;
+} arc_async_flush_data_t;
+
+static taskq_t *arc_flush_taskq;
+
+static void
+arc_flush_impl(uint64_t guid, boolean_t retry)
+{
+	arc_buf_contents_t arcs;
+
+	for (arcs = ARC_BUFC_DATA; arcs < ARC_BUFC_NUMTYPES; ++arcs) {
+		(void) arc_flush_state(arc_mru, guid, arcs, retry);
+		(void) arc_flush_state(arc_mfu, guid, arcs, retry);
+		(void) arc_flush_state(arc_mru_ghost, guid, arcs, retry);
+		(void) arc_flush_state(arc_mfu_ghost, guid, arcs, retry);
+	}
+}
+
+static void
+arc_flush_task(void *arg)
+{
+	arc_async_flush_data_t *aaf = (arc_async_flush_data_t *)arg;
+	arc_flush_impl(aaf->aaf_guid, aaf->aaf_retry);
+	kmem_free(aaf, sizeof (arc_async_flush_data_t));
+}
+
+boolean_t zfs_fastflush = B_TRUE;
+
 void
 arc_flush(spa_t *spa, boolean_t retry)
 {
 	uint64_t guid = 0;
+	boolean_t async_flush = (spa != NULL ? zfs_fastflush : FALSE);
+	arc_async_flush_data_t *aaf = NULL;
 
 	/*
 	 * If retry is B_TRUE, a spa must not be specified since we have
@@ -3874,28 +4531,40 @@
 	 * no good way to determine if all of a spa's buffers have been
 	 * evicted from an arc state.
 	 */
-	ASSERT(!retry || spa == 0);
+	ASSERT(!retry || spa == NULL);
 
-	if (spa != NULL)
+	if (spa != NULL) {
 		guid = spa_load_guid(spa);
+		if (async_flush) {
+			aaf = kmem_alloc(sizeof (arc_async_flush_data_t),
+			    KM_SLEEP);
+			aaf->aaf_guid = guid;
+			aaf->aaf_retry = retry;
+		}
+	}
 
-	(void) arc_flush_state(arc_mru, guid, ARC_BUFC_DATA, retry);
-	(void) arc_flush_state(arc_mru, guid, ARC_BUFC_METADATA, retry);
-
-	(void) arc_flush_state(arc_mfu, guid, ARC_BUFC_DATA, retry);
-	(void) arc_flush_state(arc_mfu, guid, ARC_BUFC_METADATA, retry);
-
-	(void) arc_flush_state(arc_mru_ghost, guid, ARC_BUFC_DATA, retry);
-	(void) arc_flush_state(arc_mru_ghost, guid, ARC_BUFC_METADATA, retry);
-
-	(void) arc_flush_state(arc_mfu_ghost, guid, ARC_BUFC_DATA, retry);
-	(void) arc_flush_state(arc_mfu_ghost, guid, ARC_BUFC_METADATA, retry);
+	/*
+	 * Try to flush per-spa remaining ARC ghost buffers asynchronously
+	 * while a pool is being closed.
+	 * An ARC buffer is bound to spa only by guid, so buffer can
+	 * exist even when pool has already gone. If asynchronous flushing
+	 * fails we fall back to regular (synchronous) one.
+	 * NOTE: If asynchronous flushing had not yet finished when the pool
+	 * was imported again it wouldn't be a problem, even when guids before
+	 * and after export/import are the same. We can evict only unreferenced
+	 * buffers, other are skipped.
+	 */
+	if (!async_flush || (taskq_dispatch(arc_flush_taskq, arc_flush_task,
+	    aaf, TQ_NOSLEEP) == NULL)) {
+		arc_flush_impl(guid, retry);
+		if (async_flush)
+			kmem_free(aaf, sizeof (arc_async_flush_data_t));
+	}
 }
 
 void
 arc_shrink(int64_t to_free)
 {
-	uint64_t asize = aggsum_value(&arc_size);
 	if (arc_c > arc_c_min) {
 
 		if (arc_c > arc_c_min + to_free)
@@ -3904,8 +4573,8 @@
 			arc_c = arc_c_min;
 
 		atomic_add_64(&arc_p, -(arc_p >> arc_shrink_shift));
-		if (asize < arc_c)
-			arc_c = MAX(asize, arc_c_min);
+		if (arc_c > arc_size)
+			arc_c = MAX(arc_size, arc_c_min);
 		if (arc_p > arc_c)
 			arc_p = (arc_c >> 1);
 		ASSERT(arc_c >= arc_c_min);
@@ -3912,7 +4581,7 @@
 		ASSERT((int64_t)arc_p >= 0);
 	}
 
-	if (asize > arc_c)
+	if (arc_size > arc_c)
 		(void) arc_adjust();
 }
 
@@ -4076,10 +4745,10 @@
 	extern kmem_cache_t	*abd_chunk_cache;
 
 #ifdef _KERNEL
-	if (aggsum_compare(&arc_meta_used, arc_meta_limit) >= 0) {
+	if (arc_meta_used >= arc_meta_limit || arc_ddt_size >= arc_ddt_limit) {
 		/*
-		 * We are exceeding our meta-data cache limit.
-		 * Purge some DNLC entries to release holds on meta-data.
+		 * We are exceeding our meta-data or DDT cache limit.
+		 * Purge some DNLC entries to release holds on meta-data/DDT.
 		 */
 		dnlc_reduce_cache((void *)(uintptr_t)arc_reduce_dnlc_percent);
 	}
@@ -4235,7 +4904,7 @@
 		 * be helpful and could potentially cause us to enter an
 		 * infinite loop.
 		 */
-		if (aggsum_compare(&arc_size, arc_c) <= 0|| evicted == 0) {
+		if (arc_size <= arc_c || evicted == 0) {
 			/*
 			 * We're either no longer overflowing, or we
 			 * can't evict anything more, so we should wake
@@ -4317,8 +4986,7 @@
 	 * If we're within (2 * maxblocksize) bytes of the target
 	 * cache size, increment the target cache size
 	 */
-	if (aggsum_compare(&arc_size, arc_c - (2ULL << SPA_MAXBLOCKSHIFT)) >
-	    0) {
+	if (arc_size > arc_c - (2ULL << SPA_MAXBLOCKSHIFT)) {
 		atomic_add_64(&arc_c, (int64_t)bytes);
 		if (arc_c > arc_c_max)
 			arc_c = arc_c_max;
@@ -4341,16 +5009,7 @@
 	uint64_t overflow = MAX(SPA_MAXBLOCKSIZE,
 	    arc_c >> zfs_arc_overflow_shift);
 
-	/*
-	 * We just compare the lower bound here for performance reasons. Our
-	 * primary goals are to make sure that the arc never grows without
-	 * bound, and that it can reach its maximum size. This check
-	 * accomplishes both goals. The maximum amount we could run over by is
-	 * 2 * aggsum_borrow_multiplier * NUM_CPUS * the average size of a block
-	 * in the ARC. In practice, that's in the tens of MB, which is low
-	 * enough to be safe.
-	 */
-	return (aggsum_lower_bound(&arc_size) >= arc_c + overflow);
+	return (arc_size >= arc_c + overflow);
 }
 
 static abd_t *
@@ -4359,7 +5018,7 @@
 	arc_buf_contents_t type = arc_buf_type(hdr);
 
 	arc_get_data_impl(hdr, size, tag);
-	if (type == ARC_BUFC_METADATA) {
+	if (type == ARC_BUFC_METADATA || type == ARC_BUFC_DDT) {
 		return (abd_alloc(size, B_TRUE));
 	} else {
 		ASSERT(type == ARC_BUFC_DATA);
@@ -4373,7 +5032,7 @@
 	arc_buf_contents_t type = arc_buf_type(hdr);
 
 	arc_get_data_impl(hdr, size, tag);
-	if (type == ARC_BUFC_METADATA) {
+	if (type == ARC_BUFC_METADATA || type == ARC_BUFC_DDT) {
 		return (zio_buf_alloc(size));
 	} else {
 		ASSERT(type == ARC_BUFC_DATA);
@@ -4432,7 +5091,9 @@
 	}
 
 	VERIFY3U(hdr->b_type, ==, type);
-	if (type == ARC_BUFC_METADATA) {
+	if (type == ARC_BUFC_DDT) {
+		arc_space_consume(size, ARC_SPACE_DDT);
+	} else if (type == ARC_BUFC_METADATA) {
 		arc_space_consume(size, ARC_SPACE_META);
 	} else {
 		arc_space_consume(size, ARC_SPACE_DATA);
@@ -4465,8 +5126,7 @@
 		 * If we are growing the cache, and we are adding anonymous
 		 * data, and we have outgrown arc_p, update arc_p
 		 */
-		if (aggsum_compare(&arc_size, arc_c) < 0 &&
-		    hdr->b_l1hdr.b_state == arc_anon &&
+		if (arc_size < arc_c && hdr->b_l1hdr.b_state == arc_anon &&
 		    (refcount_count(&arc_anon->arcs_size) +
 		    refcount_count(&arc_mru->arcs_size) > arc_p))
 			arc_p = MIN(arc_c, arc_p + size);
@@ -4486,7 +5146,7 @@
 	arc_buf_contents_t type = arc_buf_type(hdr);
 
 	arc_free_data_impl(hdr, size, tag);
-	if (type == ARC_BUFC_METADATA) {
+	if (type == ARC_BUFC_METADATA || type == ARC_BUFC_DDT) {
 		zio_buf_free(buf, size);
 	} else {
 		ASSERT(type == ARC_BUFC_DATA);
@@ -4514,7 +5174,9 @@
 	(void) refcount_remove_many(&state->arcs_size, size, tag);
 
 	VERIFY3U(hdr->b_type, ==, type);
-	if (type == ARC_BUFC_METADATA) {
+	if (type == ARC_BUFC_DDT) {
+		arc_space_return(size, ARC_SPACE_DDT);
+	} else if (type == ARC_BUFC_METADATA) {
 		arc_space_return(size, ARC_SPACE_META);
 	} else {
 		ASSERT(type == ARC_BUFC_DATA);
@@ -4660,6 +5322,65 @@
 	}
 }
 
+/*
+ * This routine is called by dbuf_hold() to update the arc_access() state
+ * which otherwise would be skipped for entries in the dbuf cache.
+ */
+void
+arc_buf_access(arc_buf_t *buf)
+{
+	mutex_enter(&buf->b_evict_lock);
+	arc_buf_hdr_t *hdr = buf->b_hdr;
+
+	/*
+	 * Avoid taking the hash_lock when possible as an optimization.
+	 * The header must be checked again under the hash_lock in order
+	 * to handle the case where it is concurrently being released.
+	 */
+	if (hdr->b_l1hdr.b_state == arc_anon || HDR_EMPTY(hdr)) {
+		mutex_exit(&buf->b_evict_lock);
+		return;
+	}
+
+	kmutex_t *hash_lock = HDR_LOCK(hdr);
+	mutex_enter(hash_lock);
+
+	if (hdr->b_l1hdr.b_state == arc_anon || HDR_EMPTY(hdr)) {
+		mutex_exit(hash_lock);
+		mutex_exit(&buf->b_evict_lock);
+		ARCSTAT_BUMP(arcstat_access_skip);
+		return;
+	}
+
+	mutex_exit(&buf->b_evict_lock);
+
+	ASSERT(hdr->b_l1hdr.b_state == arc_mru ||
+	    hdr->b_l1hdr.b_state == arc_mfu);
+
+	DTRACE_PROBE1(arc__hit, arc_buf_hdr_t *, hdr);
+	arc_access(hdr, hash_lock);
+	mutex_exit(hash_lock);
+
+	ARCSTAT_BUMP(arcstat_hits);
+	/*
+	 * Upstream used the ARCSTAT_CONDSTAT macro here, but they changed
+	 * the argument format for that macro, which would requie that we
+	 * go and modify all other uses of it. So it's easier to just expand
+	 * this one invocation of the macro to do the right thing.
+	 */
+	if (!HDR_PREFETCH(hdr)) {
+		if (!HDR_ISTYPE_METADATA(hdr))
+			ARCSTAT_BUMP(arcstat_demand_data_hits);
+		else
+			ARCSTAT_BUMP(arcstat_demand_metadata_hits);
+	} else {
+		if (!HDR_ISTYPE_METADATA(hdr))
+			ARCSTAT_BUMP(arcstat_prefetch_data_hits);
+		else
+			ARCSTAT_BUMP(arcstat_prefetch_metadata_hits);
+	}
+}
+
 /* a generic arc_done_func_t which you can use */
 /* ARGSUSED */
 void
@@ -4802,8 +5523,11 @@
 		arc_hdr_set_flags(hdr, ARC_FLAG_IO_ERROR);
 		if (hdr->b_l1hdr.b_state != arc_anon)
 			arc_change_state(arc_anon, hdr, hash_lock);
-		if (HDR_IN_HASH_TABLE(hdr))
+		if (HDR_IN_HASH_TABLE(hdr)) {
+			if (hash_lock)
+				arc_wait_for_krrp(hdr);
 			buf_hash_remove(hdr);
+		}
 		freeable = refcount_is_zero(&hdr->b_l1hdr.b_refcnt);
 	}
 
@@ -4846,6 +5570,55 @@
 }
 
 /*
+ * The function to process data from arc by a callback
+ * The main purpose is to directly copy data from arc to a target buffer
+ */
+int
+arc_io_bypass(spa_t *spa, const blkptr_t *bp,
+    arc_bypass_io_func func, void *arg)
+{
+	arc_buf_hdr_t *hdr;
+	kmutex_t *hash_lock = NULL;
+	int error = 0;
+	uint64_t guid = spa_load_guid(spa);
+
+top:
+	hdr = buf_hash_find(guid, bp, &hash_lock);
+	if (hdr && HDR_HAS_L1HDR(hdr) && hdr->b_l1hdr.b_bufcnt > 0 &&
+	    hdr->b_l1hdr.b_buf->b_data) {
+		if (HDR_IO_IN_PROGRESS(hdr)) {
+			cv_wait(&hdr->b_l1hdr.b_cv, hash_lock);
+			mutex_exit(hash_lock);
+			DTRACE_PROBE(arc_bypass_wait);
+			goto top;
+		}
+
+		/*
+		 * As the func is an arbitrary callback, which can block, lock
+		 * should be released not to block other threads from
+		 * performing. A counter is used to hold a reference to block
+		 * which are held by krrp.
+		 */
+
+		hdr->b_l1hdr.b_krrp++;
+		mutex_exit(hash_lock);
+
+		error = func(hdr->b_l1hdr.b_buf->b_data, hdr->b_lsize, arg);
+
+		mutex_enter(hash_lock);
+		hdr->b_l1hdr.b_krrp--;
+		cv_broadcast(&hdr->b_l1hdr.b_cv);
+		mutex_exit(hash_lock);
+
+		return (error);
+	} else {
+		if (hash_lock)
+			mutex_exit(hash_lock);
+		return (ENODATA);
+	}
+}
+
+/*
  * "Read" the block at the specified DVA (in bp) via the
  * cache.  If the block is found in the cache, invoke the provided
  * callback immediately and return.  Note that the `zio' parameter
@@ -4985,9 +5758,9 @@
 			arc_hdr_set_flags(hdr, ARC_FLAG_L2CACHE);
 		mutex_exit(hash_lock);
 		ARCSTAT_BUMP(arcstat_hits);
-		ARCSTAT_CONDSTAT(!HDR_PREFETCH(hdr),
-		    demand, prefetch, !HDR_ISTYPE_METADATA(hdr),
-		    data, metadata, hits);
+		if (HDR_ISTYPE_DDT(hdr))
+			ARCSTAT_BUMP(arcstat_ddt_hits);
+		arc_update_hit_stat(hdr, B_TRUE);
 
 		if (done)
 			done(NULL, buf, private);
@@ -5014,9 +5787,8 @@
 			}
 			if (exists != NULL) {
 				/* somebody beat us to the hash insert */
-				mutex_exit(hash_lock);
-				buf_discard_identity(hdr);
 				arc_hdr_destroy(hdr);
+				mutex_exit(hash_lock);
 				goto top; /* restart the IO request */
 			}
 		} else {
@@ -5034,7 +5806,7 @@
 			ASSERT(!HDR_IO_IN_PROGRESS(hdr));
 			ASSERT(refcount_is_zero(&hdr->b_l1hdr.b_refcnt));
 			ASSERT3P(hdr->b_l1hdr.b_buf, ==, NULL);
-			ASSERT3P(hdr->b_l1hdr.b_freeze_cksum, ==, NULL);
+			ASSERT3P(hdr->b_freeze_cksum, ==, NULL);
 
 			/*
 			 * This is a delicate dance that we play here.
@@ -5086,7 +5858,7 @@
 			devw = hdr->b_l2hdr.b_dev->l2ad_writing;
 			addr = hdr->b_l2hdr.b_daddr;
 			/*
-			 * Lock out L2ARC device removal.
+			 * Lock out device removal.
 			 */
 			if (vdev_is_dead(vd) ||
 			    !spa_config_tryenter(spa, SCL_L2ARC, vd, RW_READER))
@@ -5110,9 +5882,7 @@
 		DTRACE_PROBE4(arc__miss, arc_buf_hdr_t *, hdr, blkptr_t *, bp,
 		    uint64_t, lsize, zbookmark_phys_t *, zb);
 		ARCSTAT_BUMP(arcstat_misses);
-		ARCSTAT_CONDSTAT(!HDR_PREFETCH(hdr),
-		    demand, prefetch, !HDR_ISTYPE_METADATA(hdr),
-		    data, metadata, misses);
+		arc_update_hit_stat(hdr, B_FALSE);
 
 		if (vd != NULL && l2arc_ndev != 0 && !(l2arc_norw && devw)) {
 			/*
@@ -5133,6 +5903,8 @@
 
 				DTRACE_PROBE1(l2arc__hit, arc_buf_hdr_t *, hdr);
 				ARCSTAT_BUMP(arcstat_l2_hits);
+				if (vdev_type_is_ddt(vd))
+					ARCSTAT_BUMP(arcstat_l2_ddt_hits);
 
 				cb = kmem_zalloc(sizeof (l2arc_read_callback_t),
 				    KM_SLEEP);
@@ -5144,7 +5916,7 @@
 				asize = vdev_psize_to_asize(vd, size);
 				if (asize != size) {
 					abd = abd_alloc_for_io(asize,
-					    HDR_ISTYPE_METADATA(hdr));
+					    !HDR_ISTYPE_DATA(hdr));
 					cb->l2rcb_abd = abd;
 				} else {
 					abd = hdr->b_l1hdr.b_pabd;
@@ -5172,7 +5944,11 @@
 				    ZIO_FLAG_DONT_RETRY, B_FALSE);
 				DTRACE_PROBE2(l2arc__read, vdev_t *, vd,
 				    zio_t *, rzio);
+
 				ARCSTAT_INCR(arcstat_l2_read_bytes, size);
+				if (vdev_type_is_ddt(vd))
+					ARCSTAT_INCR(arcstat_l2_ddt_read_bytes,
+					    size);
 
 				if (*arc_flags & ARC_FLAG_NOWAIT) {
 					zio_nowait(rzio);
@@ -5444,6 +6220,8 @@
 		nhdr->b_l1hdr.b_buf = buf;
 		nhdr->b_l1hdr.b_bufcnt = 1;
 		(void) refcount_add(&nhdr->b_l1hdr.b_refcnt, tag);
+		nhdr->b_l1hdr.b_krrp = 0;
+
 		buf->b_hdr = nhdr;
 
 		mutex_exit(&buf->b_evict_lock);
@@ -5654,8 +6432,9 @@
 				ASSERT(refcount_is_zero(
 				    &exists->b_l1hdr.b_refcnt));
 				arc_change_state(arc_anon, exists, hash_lock);
-				mutex_exit(hash_lock);
+				arc_wait_for_krrp(exists);
 				arc_hdr_destroy(exists);
+				mutex_exit(hash_lock);
 				exists = buf_hash_insert(hdr, &hash_lock);
 				ASSERT3P(exists, ==, NULL);
 			} else if (zio->io_flags & ZIO_FLAG_NOPWRITE) {
@@ -5693,7 +6472,8 @@
     boolean_t l2arc, const zio_prop_t *zp, arc_done_func_t *ready,
     arc_done_func_t *children_ready, arc_done_func_t *physdone,
     arc_done_func_t *done, void *private, zio_priority_t priority,
-    int zio_flags, const zbookmark_phys_t *zb)
+    int zio_flags, const zbookmark_phys_t *zb,
+    const zio_smartcomp_info_t *smartcomp)
 {
 	arc_buf_hdr_t *hdr = buf->b_hdr;
 	arc_write_callback_t *callback;
@@ -5754,7 +6534,7 @@
 	    HDR_GET_LSIZE(hdr), arc_buf_size(buf), &localprop, arc_write_ready,
 	    (children_ready != NULL) ? arc_write_children_ready : NULL,
 	    arc_write_physdone, arc_write_done, callback,
-	    priority, zio_flags, zb);
+	    priority, zio_flags, zb, smartcomp);
 
 	return (zio);
 }
@@ -5846,9 +6626,12 @@
 	 * Note: if two requests come in concurrently, we might let them
 	 * both succeed, when one of them should fail.  Not a huge deal.
 	 */
-
 	if (reserve + arc_tempreserve + anon_size > arc_c / 2 &&
 	    anon_size > arc_c / 4) {
+		DTRACE_PROBE4(arc__tempreserve__space__throttle, uint64_t,
+		    arc_tempreserve, arc_state_t *, arc_anon, uint64_t,
+		    reserve, uint64_t, arc_c);
+
 		uint64_t meta_esize =
 		    refcount_count(&arc_anon->arcs_esize[ARC_BUFC_METADATA]);
 		uint64_t data_esize =
@@ -5865,7 +6648,8 @@
 
 static void
 arc_kstat_update_state(arc_state_t *state, kstat_named_t *size,
-    kstat_named_t *evict_data, kstat_named_t *evict_metadata)
+    kstat_named_t *evict_data, kstat_named_t *evict_metadata,
+    kstat_named_t *evict_ddt)
 {
 	size->value.ui64 = refcount_count(&state->arcs_size);
 	evict_data->value.ui64 =
@@ -5872,6 +6656,8 @@
 	    refcount_count(&state->arcs_esize[ARC_BUFC_DATA]);
 	evict_metadata->value.ui64 =
 	    refcount_count(&state->arcs_esize[ARC_BUFC_METADATA]);
+	evict_ddt->value.ui64 =
+	    refcount_count(&state->arcs_esize[ARC_BUFC_DDT]);
 }
 
 static int
@@ -5885,32 +6671,28 @@
 		arc_kstat_update_state(arc_anon,
 		    &as->arcstat_anon_size,
 		    &as->arcstat_anon_evictable_data,
-		    &as->arcstat_anon_evictable_metadata);
+		    &as->arcstat_anon_evictable_metadata,
+		    &as->arcstat_anon_evictable_ddt);
 		arc_kstat_update_state(arc_mru,
 		    &as->arcstat_mru_size,
 		    &as->arcstat_mru_evictable_data,
-		    &as->arcstat_mru_evictable_metadata);
+		    &as->arcstat_mru_evictable_metadata,
+		    &as->arcstat_mru_evictable_ddt);
 		arc_kstat_update_state(arc_mru_ghost,
 		    &as->arcstat_mru_ghost_size,
 		    &as->arcstat_mru_ghost_evictable_data,
-		    &as->arcstat_mru_ghost_evictable_metadata);
+		    &as->arcstat_mru_ghost_evictable_metadata,
+		    &as->arcstat_mru_ghost_evictable_ddt);
 		arc_kstat_update_state(arc_mfu,
 		    &as->arcstat_mfu_size,
 		    &as->arcstat_mfu_evictable_data,
-		    &as->arcstat_mfu_evictable_metadata);
+		    &as->arcstat_mfu_evictable_metadata,
+		    &as->arcstat_mfu_evictable_ddt);
 		arc_kstat_update_state(arc_mfu_ghost,
 		    &as->arcstat_mfu_ghost_size,
 		    &as->arcstat_mfu_ghost_evictable_data,
-		    &as->arcstat_mfu_ghost_evictable_metadata);
-
-		ARCSTAT(arcstat_size) = aggsum_value(&arc_size);
-		ARCSTAT(arcstat_meta_used) = aggsum_value(&arc_meta_used);
-		ARCSTAT(arcstat_data_size) = aggsum_value(&astat_data_size);
-		ARCSTAT(arcstat_metadata_size) =
-		    aggsum_value(&astat_metadata_size);
-		ARCSTAT(arcstat_hdr_size) = aggsum_value(&astat_hdr_size);
-		ARCSTAT(arcstat_other_size) = aggsum_value(&astat_other_size);
-		ARCSTAT(arcstat_l2_hdr_size) = aggsum_value(&astat_l2_hdr_size);
+		    &as->arcstat_mfu_ghost_evictable_metadata,
+		    &as->arcstat_mfu_ghost_evictable_ddt);
 	}
 
 	return (0);
@@ -5960,61 +6742,41 @@
 	arc_mfu = &ARC_mfu;
 	arc_mfu_ghost = &ARC_mfu_ghost;
 	arc_l2c_only = &ARC_l2c_only;
+	arc_buf_contents_t arcs;
 
-	arc_mru->arcs_list[ARC_BUFC_METADATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mru->arcs_list[ARC_BUFC_DATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mru_ghost->arcs_list[ARC_BUFC_METADATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mru_ghost->arcs_list[ARC_BUFC_DATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mfu->arcs_list[ARC_BUFC_METADATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mfu->arcs_list[ARC_BUFC_DATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mfu_ghost->arcs_list[ARC_BUFC_METADATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_mfu_ghost->arcs_list[ARC_BUFC_DATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_l2c_only->arcs_list[ARC_BUFC_METADATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
-	arc_l2c_only->arcs_list[ARC_BUFC_DATA] =
-	    multilist_create(sizeof (arc_buf_hdr_t),
-	    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
-	    arc_state_multilist_index_func);
+	for (arcs = ARC_BUFC_DATA; arcs < ARC_BUFC_NUMTYPES; ++arcs) {
+		arc_mru->arcs_list[arcs] =
+		    multilist_create(sizeof (arc_buf_hdr_t),
+		    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
+		    arc_state_multilist_index_func);
+		arc_mru_ghost->arcs_list[arcs] =
+		    multilist_create(sizeof (arc_buf_hdr_t),
+		    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
+			arc_state_multilist_index_func);
+		arc_mfu->arcs_list[arcs] =
+		    multilist_create(sizeof (arc_buf_hdr_t),
+		    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
+		    arc_state_multilist_index_func);
+		arc_mfu_ghost->arcs_list[arcs] =
+		    multilist_create(sizeof (arc_buf_hdr_t),
+		    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
+		    arc_state_multilist_index_func);
+		arc_l2c_only->arcs_list[arcs] =
+		    multilist_create(sizeof (arc_buf_hdr_t),
+		    offsetof(arc_buf_hdr_t, b_l1hdr.b_arc_node),
+		    arc_state_multilist_index_func);
 
-	refcount_create(&arc_anon->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_anon->arcs_esize[ARC_BUFC_DATA]);
-	refcount_create(&arc_mru->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_mru->arcs_esize[ARC_BUFC_DATA]);
-	refcount_create(&arc_mru_ghost->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_mru_ghost->arcs_esize[ARC_BUFC_DATA]);
-	refcount_create(&arc_mfu->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_mfu->arcs_esize[ARC_BUFC_DATA]);
-	refcount_create(&arc_mfu_ghost->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_mfu_ghost->arcs_esize[ARC_BUFC_DATA]);
-	refcount_create(&arc_l2c_only->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_create(&arc_l2c_only->arcs_esize[ARC_BUFC_DATA]);
+		refcount_create(&arc_anon->arcs_esize[arcs]);
+		refcount_create(&arc_mru->arcs_esize[arcs]);
+		refcount_create(&arc_mru_ghost->arcs_esize[arcs]);
+		refcount_create(&arc_mfu->arcs_esize[arcs]);
+		refcount_create(&arc_mfu_ghost->arcs_esize[arcs]);
+		refcount_create(&arc_l2c_only->arcs_esize[arcs]);
+	}
 
+	arc_flush_taskq = taskq_create("arc_flush_tq",
+	    max_ncpus, minclsyspri, 1, zfs_flush_ntasks, TASKQ_DYNAMIC);
+
 	refcount_create(&arc_anon->arcs_size);
 	refcount_create(&arc_mru->arcs_size);
 	refcount_create(&arc_mru_ghost->arcs_size);
@@ -6021,31 +6783,12 @@
 	refcount_create(&arc_mfu->arcs_size);
 	refcount_create(&arc_mfu_ghost->arcs_size);
 	refcount_create(&arc_l2c_only->arcs_size);
-
-	aggsum_init(&arc_meta_used, 0);
-	aggsum_init(&arc_size, 0);
-	aggsum_init(&astat_data_size, 0);
-	aggsum_init(&astat_metadata_size, 0);
-	aggsum_init(&astat_hdr_size, 0);
-	aggsum_init(&astat_other_size, 0);
-	aggsum_init(&astat_l2_hdr_size, 0);
 }
 
 static void
 arc_state_fini(void)
 {
-	refcount_destroy(&arc_anon->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_anon->arcs_esize[ARC_BUFC_DATA]);
-	refcount_destroy(&arc_mru->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_mru->arcs_esize[ARC_BUFC_DATA]);
-	refcount_destroy(&arc_mru_ghost->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_mru_ghost->arcs_esize[ARC_BUFC_DATA]);
-	refcount_destroy(&arc_mfu->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_mfu->arcs_esize[ARC_BUFC_DATA]);
-	refcount_destroy(&arc_mfu_ghost->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_mfu_ghost->arcs_esize[ARC_BUFC_DATA]);
-	refcount_destroy(&arc_l2c_only->arcs_esize[ARC_BUFC_METADATA]);
-	refcount_destroy(&arc_l2c_only->arcs_esize[ARC_BUFC_DATA]);
+	arc_buf_contents_t arcs;
 
 	refcount_destroy(&arc_anon->arcs_size);
 	refcount_destroy(&arc_mru->arcs_size);
